# Keyset extracter script #
The script `generate_keyset.py` is used to extract the [keyset](https://nvidia-merlin.github.io/HugeCTR/master/hugectr_embedding_training_cache.html#preprocessing) used in [Embedding Training Cache](https://nvidia-merlin.github.io/HugeCTR/master/hugectr_embedding_training_cache.html) from [Parquet](https://nvidia-merlin.github.io/HugeCTR/master/api/python_interface.html#parquet) dataset processed by NVTabular. For the data processing related information, please check the README of one of our [samples](https://github.com/NVIDIA-Merlin/HugeCTR/tree/master/samples). For the usage of keyset files, please checkout the [Embedding Training Cache Example Notebook](https://github.com/NVIDIA-Merlin/HugeCTR/blob/master/notebooks/embedding_training_cache_example.ipynb).

## Usage ##
The script should be used in the following way:

```
python generate_keyset.py --src_dir_path ./path/to/read/data/ --keyset_path ./path/to/store/keyset --cat_features_pos 0 1 2 3 4 --slot_size_array 283 12 66 7 1003 --int32_keyset False
```
where
* `src_dir_path`, string, is the directory path to read your parquet files. This is required.
* `keyset_path`, string, is the file path to store the generated keyset file. This is required.
* `cat_features_pos`, list of integers, is the positions of categorical features inthe dataset. This is optional. The default values are from 14 to 39, which are the positions in Criteo Dataset.
* `slot_size_array`, list of integers, is the offsets to add for each categorical feature. Please checkout [Parquet](https://nvidia-merlin.github.io/HugeCTR/master/api/python_interface.html#parquet) for more detail. This is optional. The default values are all 0s.
* `int32_keyset_array`, boolean, indicates whether you want your keys to be int32 or not. This is optional and the default value is False, which means int64.

**Please make sure that `cat_features_pos` and `slot_size_array` have the same length.**
